# approve-api
The simple API to request a user's approval on anything via email + sms.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.2
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import approve_api 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import approve_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import approve_api
from approve_api.rest import ApiException
from pprint import pprint

# Configure HTTP basic authorization: apiKey
approve_api.configuration.username = 'YOUR_USERNAME'
approve_api.configuration.password = 'YOUR_PASSWORD'
# create an instance of the API class
api_instance = approve_api.ApproveApi()
user = 'user_example' # str | The user to send the approval request to. Can be either an email address or a phone number.
body = 'body_example' # str | The body of the approval request to show the user.
title = 'title_example' # str | The title of an approval request. Defaults to an empty string. (optional)
approve_text = 'approve_text_example' # str | The approve action text. Defaults to 'Approve'. (optional)
reject_text = 'reject_text_example' # str | The reject action text. Defaults to 'Reject'. (optional)
long_poll = true # bool | If true, the request waits (long-polls) until the user responds to the prompt or more than 10 minutes pass. Defaults to false. (optional)

try:
    # Sending a prompt
    api_response = api_instance.create_prompt(user, body, title=title, approve_text=approve_text, reject_text=reject_text, long_poll=long_poll)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ApproveApi->create_prompt: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://approve.sh*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApproveApi* | [**create_prompt**](docs/ApproveApi.md#create_prompt) | **POST** /prompt | Sending a prompt
*ApproveApi* | [**get_prompt**](docs/ApproveApi.md#get_prompt) | **GET** /prompt/{id} | Retrieve a prompt
*ApproveApi* | [**get_prompt_status**](docs/ApproveApi.md#get_prompt_status) | **GET** /prompt/{id}/status | Check prompt status


## Documentation For Models

 - [Error](docs/Error.md)
 - [Prompt](docs/Prompt.md)
 - [PromptAnswer](docs/PromptAnswer.md)
 - [PromptStatus](docs/PromptStatus.md)


## Documentation For Authorization


## apiKey

- **Type**: HTTP basic authentication


## Author

dev@approveapi.com

