# coding: utf-8

"""
    ApproveAPI

    The simple API to request a user's approval on anything via email + sms.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: dev@approveapi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from approve_api.api_client import ApiClient


class ApproveApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_prompt(self, user, body, **kwargs):  # noqa: E501
        """Sending a prompt  # noqa: E501

        Creates a prompt and pushes it to the user (sends via email, sms, or other supported protocols).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_prompt(user, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param str user: The user to send the approval request to. Can be either an email address or a phone number. (required)
        :param str body: The body of the approval request to show the user. (required)
        :param str title: The title of an approval request. Defaults to an empty string.
        :param str approve_text: The approve action text. Defaults to 'Approve'.
        :param str reject_text: The reject action text. Defaults to 'Reject'.
        :param bool long_poll: If true, the request waits (long-polls) until the user responds to the prompt or more than 10 minutes pass. Defaults to false.
        :return: Prompt
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_prompt_with_http_info(user, body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_prompt_with_http_info(user, body, **kwargs)  # noqa: E501
            return data

    def create_prompt_with_http_info(self, user, body, **kwargs):  # noqa: E501
        """Sending a prompt  # noqa: E501

        Creates a prompt and pushes it to the user (sends via email, sms, or other supported protocols).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_prompt_with_http_info(user, body, async=True)
        >>> result = thread.get()

        :param async bool
        :param str user: The user to send the approval request to. Can be either an email address or a phone number. (required)
        :param str body: The body of the approval request to show the user. (required)
        :param str title: The title of an approval request. Defaults to an empty string.
        :param str approve_text: The approve action text. Defaults to 'Approve'.
        :param str reject_text: The reject action text. Defaults to 'Reject'.
        :param bool long_poll: If true, the request waits (long-polls) until the user responds to the prompt or more than 10 minutes pass. Defaults to false.
        :return: Prompt
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'body', 'title', 'approve_text', 'reject_text', 'long_poll']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_prompt" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `create_prompt`")  # noqa: E501
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_prompt`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'user' in params:
            form_params.append(('user', params['user']))  # noqa: E501
        if 'body' in params:
            form_params.append(('body', params['body']))  # noqa: E501
        if 'title' in params:
            form_params.append(('title', params['title']))  # noqa: E501
        if 'approve_text' in params:
            form_params.append(('approve_text', params['approve_text']))  # noqa: E501
        if 'reject_text' in params:
            form_params.append(('reject_text', params['reject_text']))  # noqa: E501
        if 'long_poll' in params:
            form_params.append(('long_poll', params['long_poll']))  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/prompt', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Prompt',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_prompt(self, id, **kwargs):  # noqa: E501
        """Retrieve a prompt  # noqa: E501

        Retrieve the prompt object with the given ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_prompt(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: The identifier for a pending or completed prompt. This is returned when you create a prompt. (required)
        :param bool long_poll: If true, the request waits (long-polls) until the user responds to the prompt or more than 10 minutes pass. Defaults to false.
        :return: Prompt
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_prompt_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_prompt_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_prompt_with_http_info(self, id, **kwargs):  # noqa: E501
        """Retrieve a prompt  # noqa: E501

        Retrieve the prompt object with the given ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_prompt_with_http_info(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: The identifier for a pending or completed prompt. This is returned when you create a prompt. (required)
        :param bool long_poll: If true, the request waits (long-polls) until the user responds to the prompt or more than 10 minutes pass. Defaults to false.
        :return: Prompt
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'long_poll']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_prompt" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_prompt`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'long_poll' in params:
            query_params.append(('long_poll', params['long_poll']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKey']  # noqa: E501

        return self.api_client.call_api(
            '/prompt/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Prompt',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_prompt_status(self, id, **kwargs):  # noqa: E501
        """Check prompt status  # noqa: E501

        Returns whether a prompt has been completed by the user. This request does not require authentication, and so can be used client-side without sharing API credentials.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_prompt_status(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: The prompt identifier. (required)
        :return: PromptStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_prompt_status_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_prompt_status_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_prompt_status_with_http_info(self, id, **kwargs):  # noqa: E501
        """Check prompt status  # noqa: E501

        Returns whether a prompt has been completed by the user. This request does not require authentication, and so can be used client-side without sharing API credentials.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_prompt_status_with_http_info(id, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: The prompt identifier. (required)
        :return: PromptStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_prompt_status" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_prompt_status`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/x-www-form-urlencoded'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/prompt/{id}/status', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PromptStatus',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
